/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables;


import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Indexes;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Keys;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.records.MmRipartizioneCaricoCcidRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;
import org.jooq.types.UInteger;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class MmRipartizioneCaricoCcid extends TableImpl<MmRipartizioneCaricoCcidRecord> {

    private static final long serialVersionUID = 416567714;

    /**
     * The reference instance of <code>MM_RIPARTIZIONE_CARICO_CCID</code>
     */
    public static final MmRipartizioneCaricoCcid MM_RIPARTIZIONE_CARICO_CCID = new MmRipartizioneCaricoCcid();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<MmRipartizioneCaricoCcidRecord> getRecordType() {
        return MmRipartizioneCaricoCcidRecord.class;
    }

    /**
     * The column <code>MM_RIPARTIZIONE_CARICO_CCID.ID</code>.
     */
    public final TableField<MmRipartizioneCaricoCcidRecord, Long> ID = createField("ID", org.jooq.impl.SQLDataType.BIGINT.nullable(false).identity(true), this, "");

    /**
     * The column <code>MM_RIPARTIZIONE_CARICO_CCID.ID_RIPARTIZIONE_CARICO</code>.
     */
    public final TableField<MmRipartizioneCaricoCcidRecord, Long> ID_RIPARTIZIONE_CARICO = createField("ID_RIPARTIZIONE_CARICO", org.jooq.impl.SQLDataType.BIGINT.nullable(false), this, "");

    /**
     * The column <code>MM_RIPARTIZIONE_CARICO_CCID.ID_INVOICE_ITEM_TO_CCID</code>.
     */
    public final TableField<MmRipartizioneCaricoCcidRecord, UInteger> ID_INVOICE_ITEM_TO_CCID = createField("ID_INVOICE_ITEM_TO_CCID", org.jooq.impl.SQLDataType.INTEGERUNSIGNED.nullable(false), this, "");

    /**
     * Create a <code>MM_RIPARTIZIONE_CARICO_CCID</code> table reference
     */
    public MmRipartizioneCaricoCcid() {
        this(DSL.name("MM_RIPARTIZIONE_CARICO_CCID"), null);
    }

    /**
     * Create an aliased <code>MM_RIPARTIZIONE_CARICO_CCID</code> table reference
     */
    public MmRipartizioneCaricoCcid(String alias) {
        this(DSL.name(alias), MM_RIPARTIZIONE_CARICO_CCID);
    }

    /**
     * Create an aliased <code>MM_RIPARTIZIONE_CARICO_CCID</code> table reference
     */
    public MmRipartizioneCaricoCcid(Name alias) {
        this(alias, MM_RIPARTIZIONE_CARICO_CCID);
    }

    private MmRipartizioneCaricoCcid(Name alias, Table<MmRipartizioneCaricoCcidRecord> aliased) {
        this(alias, aliased, null);
    }

    private MmRipartizioneCaricoCcid(Name alias, Table<MmRipartizioneCaricoCcidRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> MmRipartizioneCaricoCcid(Table<O> child, ForeignKey<O, MmRipartizioneCaricoCcidRecord> key) {
        super(child, key, MM_RIPARTIZIONE_CARICO_CCID);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.MM_RIPARTIZIONE_CARICO_CCID_MM_RIPARTIZIONE_CARICO_CCID_ID_UINDEX, Indexes.MM_RIPARTIZIONE_CARICO_CCID_MM_RIPARTIZIONE_CARICO_CCID_INVOICE_ITEM_TO_CCID_ID_FK, Indexes.MM_RIPARTIZIONE_CARICO_CCID_MM_RIPARTIZIONE_CARICO_CCID_MM_RIPARTIZIONE_CARICHI_ID_FK, Indexes.MM_RIPARTIZIONE_CARICO_CCID_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<MmRipartizioneCaricoCcidRecord, Long> getIdentity() {
        return Keys.IDENTITY_MM_RIPARTIZIONE_CARICO_CCID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<MmRipartizioneCaricoCcidRecord> getPrimaryKey() {
        return Keys.KEY_MM_RIPARTIZIONE_CARICO_CCID_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<MmRipartizioneCaricoCcidRecord>> getKeys() {
        return Arrays.<UniqueKey<MmRipartizioneCaricoCcidRecord>>asList(Keys.KEY_MM_RIPARTIZIONE_CARICO_CCID_PRIMARY, Keys.KEY_MM_RIPARTIZIONE_CARICO_CCID_MM_RIPARTIZIONE_CARICO_CCID_ID_UINDEX);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<MmRipartizioneCaricoCcidRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<MmRipartizioneCaricoCcidRecord, ?>>asList(Keys.MM_RIPARTIZIONE_CARICO_CCID_MM_RIPARTIZIONE_CARICHI_ID_FK, Keys.MM_RIPARTIZIONE_CARICO_CCID_INVOICE_ITEM_TO_CCID_ID_FK);
    }

    public MmRipartizioneCarico mmRipartizioneCarico() {
        return new MmRipartizioneCarico(this, Keys.MM_RIPARTIZIONE_CARICO_CCID_MM_RIPARTIZIONE_CARICHI_ID_FK);
    }

    public InvoiceItemToCcid invoiceItemToCcid() {
        return new InvoiceItemToCcid(this, Keys.MM_RIPARTIZIONE_CARICO_CCID_INVOICE_ITEM_TO_CCID_ID_FK);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public MmRipartizioneCaricoCcid as(String alias) {
        return new MmRipartizioneCaricoCcid(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public MmRipartizioneCaricoCcid as(Name alias) {
        return new MmRipartizioneCaricoCcid(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public MmRipartizioneCaricoCcid rename(String name) {
        return new MmRipartizioneCaricoCcid(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public MmRipartizioneCaricoCcid rename(Name name) {
        return new MmRipartizioneCaricoCcid(name, null);
    }
}
